;====================================================================
Pro DI_winset, winindex, _extra=_extra, show=show, erase=erase

device,window_state=window_state
if not window_state[winindex] then window,winindex,_extra=_extra else wset,winindex

if keyword_set(erase) then erase

if keyword_set(show) then wshow,winindex

return
end

;====================================================================
function transf4star_shape,incl,phi,p,xx
;
; Coordinate transformation
;
  a=dblarr(3,3)
  TORAD=!DPI/180
  COSI=  COS(incl*TORAD) & SINI=  SIN(incl*TORAD)
  COSPHI=COS(phi*TORAD)  & SINPHI=SIN(phi*TORAD)
  COSP=  COS(p*TORAD)    & SINP=  SIN(p*TORAD)
  a=[[COSPHI,-SINPHI, 0.D0], $
     [SINPHI, COSPHI, 0.D0], $
     [  0.D0,   0.D0, 1.D0]]
  b=[[1.d0, 0.d0, 0.d0], $
     [0.d0, COSI,-SINI], $
     [0.d0, SINI, COSI]]
  c=[[COSP, 0.D0,-SINP], $
     [0.D0, 1.D0, 0.D0], $
     [SINP, 0.D0, COSP]]
  s=size(xx)
  if(s(0) lt 3) then begin
    x=a#xx & x=b#x & x=c#x
  endif else if(s(0) eq 3) then begin
    n=s(2) & m=s(3)
    x=a#xx & x=b#x & x=c#x
    x=dblarr(3,n,m)
    for j=0,m-1 do x(*,*,j)=a#xx(*,*,j)
    for j=0,m-1 do x(*,*,j)=b# x(*,*,j)
    for j=0,m-1 do x(*,*,j)=c# x(*,*,j)
  endif else if(s(0) eq 4) then begin
    n=s(2) & m=s(3) & k=s(4)
    x=dblarr(3,n,m,k)
    for l=0,k-1 do for j=0,m-1 do x(*,*,j,l)=a#xx(*,*,j,l)
    for l=0,k-1 do for j=0,m-1 do x(*,*,j,l)=b# x(*,*,j,l)
    for l=0,k-1 do for j=0,m-1 do x(*,*,j,l)=c# x(*,*,j,l)
  endif
  return,x
end

;====================================================================
function triangle,x,y,nx,ny

  k=sort(y)
  x1=x(k(0)) & x2=x(k(1)) & x3=x(k(2))
  y1=y(k(0)) & y2=y(k(1)) & y3=y(k(2))
  n=(floor(y3)-floor(y1))*(floor(max(x))-floor(min(x)))
  if(n le 0) then return,-1
  a31=(x1-x3)/(y1-y3)
  ii=lonarr(2*n)
  n=0
  if(x2 gt (y2-y3)*a31+x3) then begin
    if(floor(y1) lt floor(y2)) then begin
      a12=(x2-x1)/(y2-y1)
      for i=ceil(y1),floor(y2) do begin
        l1=ceil((i-y3)*a31+x3) & l2=floor((i-y1)*a12+x1)
        n12=l2-l1
        if(n12 ge 0) then begin
          ii(n:n+n12)=i*nx+l1+lindgen(n12+1)
          n=n+n12+1
        endif
      endfor
    endif
    if(floor(y2) lt floor(y3)) then begin
      a23=(x3-x2)/(y3-y2)
      for i=ceil(y2),floor(y3) do begin
        l1=ceil((i-y3)*a31+x3) & l2=floor((i-y2)*a23+x2)
        n23=l2-l1
        if(n23 ge 0) then begin
          ii(n:n+n23)=i*nx+l1+lindgen(n23+1)
          n=n+n23+1
        endif
      endfor
    endif
  endif else begin
    if(floor(y1) lt floor(y2)) then begin
      a12=(x2-x1)/(y2-y1)
      for i=ceil(y1),floor(y2) do begin
        l1=ceil((i-y1)*a12+x1) & l2=floor((i-y3)*a31+x3)
        n12=l2-l1
        if(n12 ge 0) then begin
          ii(n:n+n12)=i*nx+l1+lindgen(n12+1)
          n=n+n12+1
        endif
      endfor
    endif
    if(floor(y2) lt floor(y3)) then begin
      a23=(x3-x2)/(y3-y2)
      for i=ceil(y2),floor(y3) do begin
        l1=ceil((i-y2)*a23+x2) & l2=floor((i-y3)*a31+x3)
        n23=l2-l1
        if(n23 ge 0) then begin
          ii(n:n+n23)=i*nx+l1+lindgen(n23+1)
          n=n+n23+1
        endif
      endfor
    endif
  endelse
  if(n le 0) then return,-1
  return,ii(0:n-1)
end

;====================================================================
function star_shape,n,m,alpha,beta,xx,nbox_x,nbox_y,light,background=background

;
; Setup object
;
if not keyword_set(background) then background=255
img=bytarr(nbox_x,nbox_y)+background
pointer=lonarr(nbox_x,nbox_y)
x=transf4star_shape(alpha,beta,0,xx)
x(0,*,*)=(x(0,*,*)+1)*nbox_x/2
x(1,*,*)=(x(1,*,*)+1)*nbox_x/2+(nbox_y-nbox_x)*0.5
x(2,*,*)=x(2,*,*)*nbox_x/2
;
; Store polygons and normals
;
xxa=dblarr(n-1,m-1,3) & for i=0,2 do xxa(*,*,i)=x(i,1:n-1,0:m-2)
xxb=dblarr(n-1,m-1,3) & for i=0,2 do xxb(*,*,i)=x(i,0:n-2,0:m-2)
xxc=dblarr(n-1,m-1,3) & for i=0,2 do xxc(*,*,i)=x(i,1:n-1,1:m-1)
xxd=dblarr(n-1,m-1,3) & for i=0,2 do xxd(*,*,i)=x(i,0:n-2,1:m-1)
d1=xxa-xxb & d2=xxc-xxb
dx1=d1(*,*,1)*d2(*,*,2)-d2(*,*,1)*d1(*,*,2)
dy1=d1(*,*,2)*d2(*,*,0)-d2(*,*,2)*d1(*,*,0)
dz1=d1(*,*,0)*d2(*,*,1)-d2(*,*,0)*d1(*,*,1)
norm1=sqrt(dx1*dx1+dy1*dy1+dz1*dz1)
d1=xxd-xxb
dx2=d2(*,*,1)*d1(*,*,2)-d1(*,*,1)*d2(*,*,2)
dy2=d2(*,*,2)*d1(*,*,0)-d1(*,*,2)*d2(*,*,0)
dz2=d2(*,*,0)*d1(*,*,1)-d1(*,*,0)*d2(*,*,1)
norm2=sqrt(dx2*dx2+dy2*dy2+dz2*dz2)
ii=where((dz1 lt 0) or (dz2 lt 0), ll)
kk1=where(norm1(ii) eq 0,nkk1)
kk2=where(norm2(ii) eq 0,nkk2)
if(nkk1 gt 0) then norm1(ii(kk1))=1
if(nkk2 gt 0) then norm2(ii(kk2))=1
nr=dblarr(ll,2,3)
nr(*,0,0)=dx1(ii)/norm1(ii) & nr(*,1,0)=dx2(ii)/norm2(ii)
nr(*,0,1)=dy1(ii)/norm1(ii) & nr(*,1,1)=dy2(ii)/norm2(ii)
nr(*,0,2)=dz1(ii)/norm1(ii) & nr(*,1,2)=dz2(ii)/norm2(ii)
if(nkk1 gt 0) then nr(kk1,0,*)=nr(kk1,1,*)
if(nkk2 gt 0) then nr(kk2,1,*)=nr(kk2,0,*)
pl=dblarr(ll,3,4)
for i=0,2 do begin
  di=long(i)*long(n-1)*long(m-1)
  pl(*,i,0)=xxa(ii+di)
  pl(*,i,1)=xxb(ii+di)
  pl(*,i,2)=xxc(ii+di)
  pl(*,i,3)=xxd(ii+di)
endfor
color=light(ii)
ll=ll-1
;clrmax=min([253,!d.n_colors-1])-3
;clrmin=60
;k=reverse(sort(pl(*,2,0)))
; this ensures sorting of polygons in ascending z
k=sort(total(pl(*,2,*),3)/4.)
max_n=10000L
indd=lonarr(max_n)
for j=0L,ll do begin
  l=k(j)
;  clr=fix(acos(total(nr(l,0,*)*light))/!DPI*(clrmax-clrmin))+clrmin
  clr=color(l)
  if(nr(l,0,2) lt 0) then begin
    ind=triangle(pl(l,0,0:2),pl(l,1,0:2),nbox_x,nbox_y)
    if((size(ind))(0) gt 0) then begin
      img(ind)=clr & pointer(ind)=l
    endif
  endif
;  clr=fix(acos(total(nr(l,1,*)*light))/!DPI*(clrmax-clrmin))+clrmin
  clr=color(l)
  if(nr(l,1,2) lt 0) then begin
    ind=triangle(pl(l,0,1:3),pl(l,1,1:3),nbox_x,nbox_y)
    if((size(ind))(0) gt 0) then begin
      img(ind)=clr & pointer(ind)=l
    endif
  endif
endfor 
return,img 
end

;===========================================================================
Function DI_Transform,order,alpha,beta,xx
;
; Coordinate transformation:
;
; If order==1 then
;   1. Tilt Z-axis by alpha degrees.
;   2. Rotate around Z-axis by beta degrees.
; else
;   1. Rotate around Z-axis by beta degrees.
;   2. Tilt Z-axis by alpha degrees.
;
; Coordinate system: X - horizontal in image plane pointing right
;                    Y - vertical in image plain pointing up
;                    Z - towards the observer

  TORAD=!DPI/180
  COSA=COS(alpha*TORAD) & SINA=SIN(alpha*TORAD)
  COSB=COS(beta *TORAD) & SINB=SIN(beta *TORAD)

; Tilt of Z axis
  a=[[1.d0, 0.d0, 0.d0], $
     [0.d0, COSA,-SINA], $
     [0.d0, SINA, COSA]]

; Rotation around Z axis
  b=[[COSB,-SINB, 0.d0], $
     [SINB, COSB, 0.d0], $
     [0.d0, 0.d0, 1.d0]]

  s=size(xx)
  if(s(0) lt 3) then begin
    if(order eq 1) then begin
      x=a#xx & x=b#x
    endif else begin
      x=b#xx & x=a#x
    endelse
  endif else if(s(0) eq 3) then begin
    n=s(2) & m=s(3)
    x=dblarr(3,n,m)
    if(order eq 1) then begin
      for j=0,m-1 do x(*,*,j)=a#xx(*,*,j)
      for j=0,m-1 do x(*,*,j)=b# x(*,*,j)
    endif else begin
      for j=0,m-1 do x(*,*,j)=b#xx(*,*,j)
      for j=0,m-1 do x(*,*,j)=a# x(*,*,j)
    endelse
  endif
  return,x
end

;===========================================================================
Pro DI_PltGrid,angle,long,cl,equ=equ

; spherical grid on the stellar surface

  thickgrid=1.0

  hcirc=dblarr(361,2) & dr=1.0
  hcirc[*,0]=sin(dindgen(361)*!dtor)*dr
  hcirc[*,1]=cos(dindgen(361)*!dtor)*dr
  oplot,hcirc[*,0],hcirc[*,1],thick=thickgrid,col=cl

  c0=dblarr(3,361)
  if keyword_set(equ) then begin
    ltt=0.
    rd=sin((90.-abs(ltt))*!dtor)
    c0[0,*]=hcirc[*,0]*rd
    c0[2,*]=hcirc[*,1]*rd
    c0[1,*]=-dr*cos((90.-ltt)*!dtor)
    c1=DI_Transform(0,angle,0,c0)
    ii=where(c1[1,*] le 0,nii)
    oplot,c1[0,ii],c1[2,ii],thick=4,col=0
    oplot,c1[0,ii],c1[2,ii],thick=1,col=255

    cp=dblarr(3,2)
    cp[0,*]=0.
    cp[2,*]=0.
    cp[1,*]=((-1.)^(angle gt 90.))*dr*[1.,1.3]
    c1=DI_Transform(0,angle,0,cp)
    plots,c1[0,*],-c1[2,*],thick=4,col=0
    plots,c1[0,*],-c1[2,*],thick=1,col=255
    
    return
  endif

; latitudes
  
  nlats=5 & dlat=180./(nlats+1)
   
  for il=0,nlats-1 do begin
   ltt=90.-dlat*(il+1)
   rd=sin((90.-abs(ltt))*!dtor)
   c0[0,*]=hcirc[*,0]*rd
   c0[2,*]=hcirc[*,1]*rd
   c0[1,*]=-dr*cos((90.-ltt)*!dtor)
   c1=DI_Transform(0,angle,0,c0)
   ii=where(c1[1,*] le 0,nii)
   if(nii gt 0) then oplot,c1[0,ii],c1[2,ii],thick=thickgrid,col=cl
  endfor
  
; longitudes
  
  hcirc[*,0]= sin(dindgen(361)*!dtor)*dr
  hcirc[*,1]=(-1+2*(angle gt 90.))*cos(dindgen(361)*!dtor)*dr
  nlons=6 & dlon=360./nlons/2.
   
  for il=0,6-1 do begin  
   ln=90.+dlon*il-long
   c0[0,*]=hcirc[*,0]
   c0[2,*]=hcirc[*,1]
   c0[1,*]=0.d0
   c1=DI_Transform(0,90.-angle,ln,c0)
   ii=where(c1[1,*] ge 0,nii)
   if(nii gt 0) then oplot,c1[0,ii],c1[2,ii],thick=thickgrid,col=cl
  endfor

  return
end

;===========================================================================
Pro DI_GridInit, ntot, grid

; generate stellar surface grid

  nlat=round(0.5D0*(1.D0+sqrt(1.D0+!DPI*ntot)))-1
  nlon=intarr(nlat)
  xlat=!DPI*(dindgen(nlat)+0.5D0)/nlat-!DPI/2.D0
  xcirc=2.D0*cos(xlat[1:*])
  nlon[1:*]=round(xcirc*nlat)+1
  nlon[0]=ntot-total(nlon[1:*])
  if(abs(nlon[0]-nlon[nlat-1]) gt nlat) then $
    nlon[1:*]=nlon[1:*]+(nlon[0]-nlon[nlat-1])/nlat
  nlon[0]=ntot-total(nlon[1:*])
  if(nlon[0] lt nlon[nlat-1]) then $
    nlon[1:*]=nlon[1:*]-1
  nlon[0]=ntot-total(nlon[1:*])

; generate Descartes coordinates for the surface grid in 
; stellar coordinates, areas of surface elements and
; regularization indices: (lower,upper,right,left)

  x0=dblarr(3,ntot) & j=0
  latitude=dblarr(ntot) & longitude=dblarr(ntot)
  sa=dblarr(ntot) & ireg=intarr(4,ntot)
  slt=[0.,(xlat[1:nlat-1]+xlat[0:nlat-2])/2.+!dpi/2.,!dpi]
  for i=0,nlat-1 do begin
    coslat=cos(xlat[i]) & sinlat=sin(xlat[i])
    xlon=2*!DPI*(dindgen(nlon[i])+0.5)/nlon[i]
    ;xlon=2*!DPI*(dindgen(nlon[i])+0.5*(i mod 2))/nlon[i]
    sinlon=sin(xlon) & coslon=cos(xlon)
    x0[0,j:j+nlon[i]-1]= coslat*sinlon
    x0[1,j:j+nlon[i]-1]=-coslat*coslon
    x0[2,j:j+nlon[i]-1]= sinlat
    latitude [j:j+nlon[i]-1]=xlat[i]
    longitude[j:j+nlon[i]-1]=xlon
    sa[j:j+nlon[i]-1]=2.*!dpi* $
      (cos(slt[i])-cos(slt[i+1]))/nlon[i]
    ireg[2,j:j+nlon[i]-1]=shift(j+indgen(nlon[i]),-1)
    ireg[3,j:j+nlon[i]-1]=shift(j+indgen(nlon[i]), 1)
    if(i gt 0) then il_lo=j-nlon[i-1]+indgen(nlon[i-1]) $
               else il_lo=j+nlon[i  ]+indgen(nlon[i+1])
    if(i lt nlat-1) then il_up=j+nlon[i]+indgen(nlon[i+1]) $
                    else il_up=il_lo
    for k=j,j+nlon[i]-1 do begin
      dlat_lo=longitude[k]-longitude[il_lo]
      ll=where(abs(dlat_lo) eq min(abs(dlat_lo)))
      ireg[0,k]=il_lo[ll[0]]
      dlat_up=longitude[k]-longitude[il_up]
      ll=where(abs(dlat_up) eq min(abs(dlat_up)))
      ireg[1,k]=il_up[ll[0]]
    endfor  
    j=j+nlon[i]
  endfor

  theta=acos(x0[2,*])
  phi  =atan(x0[0,*],-x0[1,*])
  ii=where(phi lt 0,nii)
  if nii gt 0 then phi[ii]=2d0*!dpi-abs(phi[ii])

  grid={ntot:ntot,nlat:nlat,nlon:nlon,xyz:x0,lat:latitude,lon:longitude,area:sa,ireg:ireg,phi:phi,theta:theta}

end

;===========================================================================
Pro DI_CreateMap, grid, spots, map

  map=replicate(1d0,grid.ntot)
  for i=0,spots.n-1 do begin
    dlon=grid.lon-spots.tbl[0,i]*!dtor
    dlat=grid.lat-spots.tbl[1,i]*!dtor
    da=2d0*asin(sqrt(sin(0.5d0*dlat)^2+cos(spots.tbl[1,i]*!dtor)*cos(grid.lat)*sin(0.5d0*dlon)^2))
    ii=where(da le spots.tbl[2,i]*!dtor,ni)
    if ni gt 0 then map[ii]=spots.tbl[3,i]      
  endfor

end

;===========================================================================
Pro DI_Prf, grid, star, map, syn, grad, time=time, phase=phase, vv=vv, vr=vr, nonoise=nonoise

; start timer
  t1=systime(1)

; velocity array
  if keyword_set(vv) then nv=n_elements(vv) else begin
    nv=ceil(2d0*star.vrange/star.vstep)
    vv=-star.vrange+dindgen(nv)*star.vstep
  endelse

; phase array
  if not keyword_set(phase) then phase=dindgen(star.nphases)/star.nphases

; velocity correction for each phase
  if not keyword_set(vr) then vr=dblarr(star.nphases)
  
; fixed trigonometric quantities
  cosi  =cos(star.incl*!dtor) & sini  =sin(star.incl*!dtor)
  coslat=cos(grid.lat)        & sinlat=sin(grid.lat)

; FWHM to Gaussian sigma
  sigm=star.fwhm/sqrt(8d0*alog(2d0))
  isig=(-0.5d0/sigm^2)

; initialize line profile and integrated field arrays
  prf=dblarr(n_elements(phase),nv)

; gradient if called with 5-variable input
  if n_params() eq 5 then grad=dblarr(n_elements(phase),nv,grid.ntot)
  
; phase loop
  for i=0l,n_elements(phase)-1 do begin
    coslon=cos(grid.lon+2d0*!dpi*phase[i])
    sinlon=sin(grid.lon+2d0*!dpi*phase[i])
    mu=sinlat*cosi+coslat*sini*coslon                                   
    ivis=where(mu gt 0.,nvis)	    	     	      	                
    dv=-sinlon[ivis]*coslat[ivis]*star.vsini
    avis=grid.area[ivis]*mu[ivis]*(1d0-star.limbd+star.limbd*mu[ivis])
    if star.type eq 0 then begin
      wgt=avis*map[ivis]
      wgtn=total(wgt)                                                 
      for j=0l,nv-1 do begin 
        plc=1d0-star.d*exp(isig*(vv[j]+dv-vr[i])^2)
        prf[i,j]=total(wgt*plc)/wgtn
        if n_params() eq 5 then grad[i,j,ivis]=avis*plc/wgtn-avis*prf[i,j]/wgtn
      endfor
    endif else if star.type eq 1 then begin
      wgt=avis
      wgtn=total(wgt)                                                 
      for j=0l,nv-1 do begin 
        plc=1d0-map[ivis]*star.d*exp(isig*(vv[j]+dv-vr[i])^2)
        prf[i,j]=total(wgt*plc)/wgtn
        if n_params() eq 5 then grad[i,j,ivis]=-wgt/wgtn*star.d*exp(isig*(vv[j]+dv-vr[i])^2)
      endfor    
    endif
  endfor
  
; report timer
  t2=systime(1)
  if keyword_set(time) then print,'Surface integration: '+string((t2-t1)*[1.,1./star.nphases], $
    form='(F6.2,", ",F5.2," sec.")')

; output structure
  syn={v:vv,phase:phase,prf:prf}

; add noise
  if max(strpos(tag_names(star),'SNR')) ne -1 and not keyword_set(nonoise) then begin
  ;if star.snr gt 0 then begin
    obs=syn.prf*0d0
    for i=0,star.nphases-1 do obs[i,*]=syn.prf[i,*]+randomn(seed,n_elements(syn.v))/star.snr
    syn=create_struct(syn,'obs',obs)
  endif

end

;===========================================================================
function memreg,x
xm=x/mean(x)
return, total(xm*alog(xm))
end
;===========================================================================
Function DI_func,map,dmap,star=star,grid=grid,obs=obs,invp=invp

common iterinfo,iter_info,syn_inv

  nv=n_elements(obs.v)
  er=1d0/abs(star.snr)
  if n_params() eq 2 then dmap=map*0d0

  if max(fix(strlowcase(tag_names(obs)) eq 'vr')) eq 1 then begin
    DI_Prf,grid,star,map,syn,grad,phase=obs.phase,vv=obs.v,vr=obs.vr
  endif else begin
    DI_Prf,grid,star,map,syn,grad,phase=obs.phase,vv=obs.v
  endelse
  
  dev=stddev(syn.prf-obs.obs)
  fchi=0d0
  sign=(-1)^invp.regtype
  for i=0,star.nphases-1 do begin
    fchi=fchi+sign*total((syn.prf[i,*]-obs.obs[i,*])^2/er^2)/nv
    if n_params() eq 2 then begin
      for j=0,nv-1 do dmap=dmap+sign*grad[i,j,*]*2d0/nv*(syn.prf[i,j]-obs.obs[i,j])/er^2
    endif
  endfor
  
  freg=0d0
  if invp.lambda gt 0 then begin
    if invp.regtype eq 0 then begin
      ir=grid.ireg
      for k=0,n_elements(ir[*,0])-1 do begin
        freg=freg+invp.lambda/grid.ntot*total((map-map[ir[k,*]])^2)
        if n_params() eq 2 then begin
          dmap         =dmap         +2d0*invp.lambda/grid.ntot*(map-map[ir[k,*]])
          dmap[ir[k,*]]=dmap[ir[k,*]]-2d0*invp.lambda/grid.ntot*(map-map[ir[k,*]])
        endif
      endfor
    endif else if invp.regtype eq 1 then begin
      ;xmap=(map>1d-3)*1d3
      ;freg=freg-invp.lambda/grid.ntot*total(xmap*alog(xmap))
      ;dmap=dmap-invp.lambda/grid.ntot*(alog(xmap)+1d0)

      mmap=total(map)/grid.ntot
      nmap=map/mmap     
      freg=freg-invp.lambda/grid.ntot*total(nmap*alog(nmap))  
      dmap=dmap-invp.lambda/grid.ntot*total( -nmap/total(map)*(alog(nmap)+1d0) )
      dmap=dmap-invp.lambda/grid.ntot/mmap*(alog(nmap)+1d0)
      
;      dmap1=dmap*0d0
;      delt=1d-6
;      for k=0,grid.ntot-1 do begin
;        map1=map
;        map1[k]=map[k]+delt
;        dmap1[k]=-invp.lambda/grid.ntot*(memreg(map1)-memreg(map))/delt
;      endfor
;      print,minmax(dmap1)
;      
;      dmap2=map*0d0
;      dmap2=dmap2-invp.lambda/grid.ntot*total( $
;      -map*grid.ntot^2/total(map)^2 $
;      -grid.ntot^2*map*alog(grid.ntot*map/total(map)) $
;      +grid.ntot/total(map) $
;      +grid.ntot*alog(grid.ntot*map/total(map))/total(map) $
;      )
;      print,minmax(dmap2)
;
;      dmap3=map*0d0
;      dmap3=-invp.lambda/grid.ntot*total(-map/grid.ntot/total(mmap^2)*(alog(nmap)+1d0)) $
;            -invp.lambda/grid.ntot/mmap*(alog(nmap)+1d0)
;      print,minmax(dmap3)
;      
;      stop
    endif
  endif
  
  ftot=fchi+freg
  
  iter_info={ftot:ftot,fchi:fchi,freg:freg,dev:dev}
  syn_inv=syn
  syn_inv.obs=obs.obs
  
  return,ftot
end

;===========================================================================
Pro DI_iter,func,map,iter,fnorm,grid=grid,star=star,defaults=defaults,_extra=extra

common iterinfo,iter_info,syn_inv
common tnmin_error, error_code

  if iter eq 0 then begin
    sout='Iter   Min     Max    Ftot       Fchi       Freg       Dev'
    print,sout
    if strlen(defaults.logfile) gt 1 then begin
      openw,un,defaults.logfile,/get_lun,/append
      printf,un,sout
      free_lun,un
    endif
  endif
  sout=string(iter,min(map),max(map),iter_info.ftot,iter_info.fchi,iter_info.freg, $
              iter_info.dev*100,form='(I4,2F8.3,3E11.3,F7.3,"%")')
  print,sout  
  if strlen(defaults.logfile) gt 1 then begin
    openw,un,defaults.logfile,/get_lun,/append
    printf,un,sout
    free_lun,un
  endif
  
  DI_Plot,map,syn_inv,grid,star.incl,title='Inversion',wind=1,type=star.type,$
    rin=defaults.mrange,di=defaults.di,xpos=defaults.xref

end

;===========================================================================
Pro DI_Plot,map,syn,coord,incl,wind=wind,title=title,di=di, $
            type=type,rin=rin,rout=rout,xpos=xpos,xref=xref,ypos=ypos
  
  if not keyword_set(wind) then wind=0
  if not keyword_set(title) then title='Spherical map'

  loadct,0,/si
  ;gamma_ct,0.8,/current
  tvlct,cr,cg,cb,/get
  cr[2:4]=[0.9, 0.2, 0.0]*255
  cg[2:4]=[0.0, 1.0, 0.4]*255
  cb[2:4]=[0.0, 0.0, 1.0]*255
  tvlct,cr,cg,cb
  !p.background=255

  nx=2 & ny=2
  device,get_screen_size=sz
  ;nbox=250
  nbox=round(sz[1]*0.65/(float(ny)+1))
  xsize=(nx+0.9)*nbox
  ysize=(ny+1)*nbox
  !p.charsize=1.0+0.2*(sz[0]-1920.)/640.
  ;print,sz,!p.charsize
  if not keyword_set(xpos) then xpos=wind eq 0 ? (sz[0]-2*xsize) : (sz[0]-xsize)
  if not keyword_set(ypos) then ypos=sz[1]
  DI_winset,wind,xs=xsize,ys=ysize,title=title,xpos=xpos,ypos=ypos,/erase
  xref=xpos+xsize
  rx=nx*nbox/float(xsize)
  ry=ny*nbox/float(ysize)

  nlon=coord.nlon

  nln=max(nlon)
  nlt=(size(nlon))(1)
  ll=intarr(nlt+1)
  ll(0)=0
  for i=0l,nlt-1 do ll(i+1)=ll(i)+nlon(i)
  
  map1=dblarr(nln,nlt)
  x=dindgen(nln)+0.5d0
  for i=0l,nlt-1 do begin
    lll=((dindgen(nlon[i]+2)-0.5d0)*nln)/nlon[i]
    y=[map[ll[i+1]-1],map[ll[i]:ll[i+1]-1],map[ll[i]]]
    for j=0l,nln-1 do begin
      dmin=min(abs(x[j]-lll),imin)
      map1[j,i]=y[imin]
    endfor
    ;map1[*,i]=interpol(y,lll,x)
  endfor

  if keyword_set(type) then begin
    rr=[min(-map1),max(-map1)]
    sign=-1
  endif else begin
    ;rr=[0.<min(map1),1.>max(map1)]
    rr=[0.,1.]
    sign=1
  endelse
  if keyword_set(rin) then rr=rin
  rout=rr
  light=bytscl(sign*transpose(map1),top=byte(190),min=rr[0],max=rr[1])+byte(50)

  theta=(!DPI*(dindgen(nlt+1)/nlt-0.5D0))#replicate(1.,nln+1)
  phi  =replicate(1,nlt+1)#(2*!DPI*(dindgen(nln+1)/nln))
  
  xx=dblarr(3,nlt+1,nln+1)
  xx[0,*,*]= cos(theta)*sin(phi)
  xx[1,*,*]=-cos(theta)*cos(phi)
  xx[2,*,*]= sin(theta)
  rscale=1.3d0
  xx=xx/rscale
  
  for k=0,nx*ny-1 do begin
    ix=(k mod nx)
    iy=ny-k/nx
    !p.region=[0,0,rx/float(nx),ry/float(ny)]+ix*rx*[1,0,1,0]/float(nx)+iy*ry*[0,1,0,1]/float(ny)
    !p.position=!p.region   
    plot,[-rscale,rscale],[-rscale,rscale],xs=5,ys=5,/nodata,/noerase
    psi=k*360./float(nx*ny)
    tv,star_shape(nlt+1,nln+1,incl,-psi,xx,nbox,nbox,light),ix*nbox,iy*nbox
    DI_pltgrid,incl,psi,0
    xyouts,rscale*0.8,rscale*0.8,string(psi/360.,form='(F4.2)'),/data,$
      align=0.5,col=4,chars=1.2
  endfor

  dy=0.80*nbox/float(ysize)
  !p.region=[0.09,0.055,0.09+2.0*dy,0.055+dy]
  !p.position=!p.region
  xsize1=ceil((!p.region[2]-!p.region[0])*xsize)
  ysize1=ceil((!p.region[3]-!p.region[1])*ysize)
  tv,congrid(transpose(light),xsize1,ysize1),!p.region[0]*xsize,!p.region[1]*ysize
  plot,[0,360],[-90,90],xs=1,ys=1,xtitle='Longitude (!uo!n)',ytitle='Latitude (!uo!n)',/nodata,/noerase,$
    col=0,ytickint=30.,xtickint=2*30.,yminor=2,xminor=2*2
  oplot,[0,360],[1,1]*(-incl),line=1,col=0

  !p.region=[nx*nbox/float(xsize)+0.05,0.05,0.97,0.97]
  !p.position=!p.region
  nphases=n_elements(syn.phase)
  if not keyword_set(di) then di=0.5
  ystep=di*(max(syn.prf)-min(syn.prf))
  ifobs=max(strpos(tag_names(syn),'OBS')) ne -1
  if ifobs then ystep=ystep>(di*(max(syn.obs)-min(syn.obs)))
  yr=[min(syn.prf),max(syn.prf)+ystep*(nphases-1)]
  yr=yr+(max(yr)-min(yr))*[-0.05,0.05]
  
  plot,[min(syn.v),max(syn.v)],yr,/nodata,/noerase,xs=3,ys=1,$
    xtitle='V (km s!u-1!n)',ytitle='I/I!dC!n',xminor=5,col=0
  for i=0,nphases-1 do begin
    y0=ystep*(nphases-1-i)
    if ifobs then oplot,syn.v,syn.obs[i,*]+y0,psym=10,col=0
    oplot,syn.v,syn.prf[i,*]+y0,col=2,thick=2    
    xyouts,max(syn.v)-0.13*(max(syn.v)-min(syn.v)),1.0+y0+0.2*ystep, $
      string(syn.phase[i],form='(F4.2)'),col=4
  endfor
  
  empty
end

;===========================================================================
Pro DI_Calculate, map, input, syn

  Widget_Control, /Hourglass
  DI_GridInit,input.ntot,grid 
  star={incl:input.incl,limbd:input.limbd,fwhm:input.fwhm,d:input.depth,vsini:input.vsini,type:input.type}
  DI_Prf,grid,star,map,syn,phase=input.phase,vv=input.v,vr=input.vr
  syn=create_struct(syn,'obs',input.obs)

  DI_Plot,map,syn,grid,star.incl,title='Forward calculation',$
    type=star.type,rout=mr,di=0.4;,xpos=xpos,xref=xref

end

;===========================================================================
Pro DI_Invert, map_in, map_out, obs, syn

  star={ntot:obs.ntot,type:obs.type,incl:obs.incl,vsini:obs.vsini,fwhm:obs.fwhm,$
        d:obs.depth,limbd:obs.limbd,nphases:n_elements(obs.phase),snr:obs.snr}
  DI_GridInit,star.ntot,grid

  sout=systime()
  sout=[sout,' --- Inversion ---']
  sout=[sout,' Nsurf  = '+strtrim(string(star.ntot,form='(I5)'),2)]
  sout=[sout,' Incl   = '+strtrim(string(star.incl,form='(I3," degrees")'),2)]
  sout=[sout,' Vsini  = '+strtrim(string(star.vsini,form='(F5.1," km/s")'),2)]
  sout=[sout,' Lambda = '+strtrim(string(obs.lambda,form='(E7.1)'),2)]
  sout=[sout,' Regularization type: '+(['Tikhonov','ME'])[obs.regtype]]
  ;openw,un,defaults.logfile,/get_lun,/append
  for k=0,n_elements(sout)-1 do begin
    ;printf,un,sout[k]
    print,sout[k]
  endfor
  ;free_lun,un

  defaults={di:0.6d0,rscale:1.4,logfile:'',mrange:0,xref:0}
  invp={ntot:star.ntot,vsini:star.vsini,incl:star.incl,lambda:obs.lambda,regtype:obs.regtype,maxiter:obs.maxiter}

  parinfo=replicate({value:0d0,fixed:0,tnmaxstep:0d0},star.ntot)
  parinfo.value=map_in
  parinfo[*].tnmaxstep=0.1d0

  functargs={star:star,grid:grid,obs:obs,invp:invp}    
  iterargs={star:star,grid:grid,defaults:defaults}  
  map_inv=tnmin('DI_func',niter=niter,functargs=functargs,parinfo=parinfo,$
                         quiet=0,nocatch=0,errmsg=errmsg,autoderivative=0,bestmin=bestmin,$
                         nprint=1,iterproc='DI_iter',iterargs=iterargs,maxiter=invp.maxiter,$
                         maximize=invp.regtype)

  map_out=map_inv
  DI_Prf,grid,star,map_out,syn,phase=obs.phase,vv=obs.v,vr=obs.vr,/nonoise
end

;===========================================================================
Pro DI_event, event

common geninfo,star,spots,invp,grid_input,map_input,syn_input,defaults

  Widget_Control, event.id, Get_UValue=uvalue, Get_Value=value
  if strupcase(tag_names(event, /Structure_Name)) eq 'WIDGET_TEXT_CH' then vpos = double(value) gt 0.0
  if strupcase(tag_names(event, /Structure_Name)) eq 'WIDGET_TABLE_CH' then vpos = double(value[event.x,event.y]) gt 0.0
  case uvalue of 
  'Ntot'     : star.ntot=defaults.ntot[event.index]
  'Incl'     : begin
                 if vpos then star.incl=double(value)
                 Widget_Control, event.id, set_value=string(star.incl,form='(I4)')
                 invp.incl=star.incl
                 Widget_Control, Widget_Info(event.top,find_by_uname='InclInv'), set_value=string(invp.incl,form='(I4)')                 
               endcase
  'Vsini'    : begin
                 if vpos then star.vsini=double(value)
                 star.vrange=defaults.rscale*sqrt(star.vsini^2+star.fwhm^2)
                 Widget_Control, event.id, set_value=string(star.vsini,form='(F5.1)')
                 invp.vsini=star.vsini
                 Widget_Control, Widget_Info(event.top,find_by_uname='VsiniInv'), set_value=string(invp.vsini,form='(F5.1)')
               endcase
  'Depth'    : begin
                 if vpos then star.d=double(value)
                 Widget_Control, event.id, set_value=string(star.d,form='(F5.2)')
               endcase
  'Fwhm'     : begin
                 if vpos then star.fwhm=double(value)
                 star.vrange=defaults.rscale*sqrt(star.vsini^2+star.fwhm^2)
                 Widget_Control, event.id, set_value=string(star.fwhm,form='(F5.1)')
               endcase
  'Limbd'    : begin
                 if vpos then star.limbd=double(value)
                 Widget_Control, event.id, set_value=string(star.limbd,form='(F5.2)')
               endcase
  'Vstep'    : begin
                 if vpos then star.vstep=double(value)
                 Widget_Control, event.id, set_value=string(star.vstep,form='(F5.1)')
               endcase
  'Nspot'    : begin
                 n0=spots.n
                 if fix(value) ge 0 then spots.n=fix(value)
                 Widget_Control, event.id, set_value=string(spots.n,form='(I4)')
                 if n0 eq 0 and spots.n gt 0 then $
                 Widget_Control, Widget_Info(event.top,find_by_uname='SpotTbl'), sensitive=1     
                 if spots.n lt n0 then begin
                   tbl0=spots.tbl
                   tbl1=tbl0[*,0:spots.n-1]
                   spots={n:spots.n,type:spots.type,tbl:tbl1}
                 endif else if spots.n gt n0 and n0 gt 0 then begin
                   tbl0=spots.tbl
                   tbl1=dblarr(4,spots.n)
                   tbl1[*,0:n0-1]=tbl0
                   for k=n0,spots.n-1 do tbl1[*,k]=tbl0[*,n0-1]
                   spots={n:spots.n,type:spots.type,tbl:tbl1}
                 endif
                 if spots.n ne 0 then $
                 Widget_Control, Widget_Info(event.top,find_by_uname='SpotTbl'), $
                   table_ysize=spots.n, set_value=spots.tbl, alignment=2, $
                   row_labels='Spot '+strtrim(indgen(spots.n)+1,2), form='(F5.1)' else $
                 Widget_Control, Widget_Info(event.top,find_by_uname='SpotTbl'), sensitive=0     
               endcase
  'SpotType' : begin
                 spots.type=event.index
                 star.type=spots.type
                 spots.tbl[3,*]=defaults.c_spot[spots.type]
                 Widget_Control, Widget_Info(event.top,find_by_uname='SpotTbl'), $
                   set_value=spots.tbl   
                 invp.lambda=invp.regtype eq 0 ? defaults.lambda_tik[spots.type] : defaults.lambda_mem[spots.type]
                 Widget_Control, Widget_Info(event.top,find_by_uname='RegVal'), $
                   set_value=string(invp.lambda,form='(e7.1)')                    
                 star.snr=defaults.snr[spots.type]
                 Widget_Control, Widget_Info(event.top,find_by_uname='SNRval'), $
                   set_value=string(star.snr,form='(I5)')                    
               endcase
  'SpotTbl'  : begin
                 if event.x le 1 then tbl=value else $
                 if event.x ge 2 then if vpos then tbl=value
                 spots.tbl=tbl
                 Widget_Control, Widget_Info(event.top,find_by_uname='SpotTbl'), $
                   set_value=spots.tbl    
               endcase
  'Nphase'   : begin
                 if vpos then star.nphases=fix(value)
                 Widget_Control, event.id, set_value=string(star.nphases,form='(I4)')
               endcase
  'Noise'    : begin
                 if event.select eq 1 then star.snr= abs(star.snr)
                 if event.select eq 0 then star.snr=-abs(star.snr)
                 Widget_Control, Widget_Info(event.top,find_by_uname='SNRlbl'), sensitive=event.select
                 Widget_Control, Widget_Info(event.top,find_by_uname='SNRval'), sensitive=event.select                 
               endcase
  'SNRval'   : begin
                 if vpos then star.snr=double(value)
                 Widget_Control, event.id, set_value=string(star.snr,form='(I5)')
               endcase
  'NtotInv'  : invp.ntot=defaults.ntot[event.index]
  'InclInv'  : begin
                 if vpos then invp.incl=double(value)
                 Widget_Control, event.id, set_value=string(invp.incl,form='(I4)')
               endcase
  'VsiniInv' : begin
                 if vpos then invp.vsini=double(value)
                 Widget_Control, event.id, set_value=string(invp.vsini,form='(F5.1)')
               endcase
  'RegType'  : begin
                 invp.regtype=event.index
                 invp.lambda=invp.regtype eq 0 ? defaults.lambda_tik[spots.type] : defaults.lambda_mem[spots.type]
                 Widget_Control, Widget_Info(event.top,find_by_uname='RegVal'), $
                   set_value=string(invp.lambda,form='(e7.1)')                    
                 ;if event.index eq 1 then begin
                 ;  print,'ME regularisation not yet implemented'
                 ;  Widget_Control, event.id, set_droplist_select=invp.regtype
                 ;endif
               endcase
  'RegVal'   : begin
                 if vpos then invp.lambda=double(value)
                 Widget_Control, event.id, set_value=string(invp.lambda,form='(e7.1)')
               endcase
  'PrfCalc'  : begin
                 Widget_Control, /Hourglass
                 DI_GridInit,star.ntot,grid_input                     ; Intialize surface grid
                 DI_CreateMap,grid_input,spots,map_input              ; Create input map
                 DI_Prf,grid_input,star,map_input,syn_input           ; Compute line profiles
                 
                 g=Widget_Info(event.top, /geometry) 
                 xpos=g.xsize+g.xoffset+1                 
                 DI_Plot,map_input,syn_input,grid_input,star.incl, $  ; Plot initial map and line profiles
                   title='Forward calculation',type=star.type,     $
                   rout=mr,di=defaults.di,xpos=xpos,xref=xref
                 if max(strpos(tag_names(defaults),'MRANGE')) ne -1 then defaults.mrange=mr $
                 else defaults=create_struct(defaults,'mrange',mr)
                 if max(strpos(tag_names(defaults),'XREF')) ne -1 then defaults.xref=xref $
                 else defaults=create_struct(defaults,'xref',xref)
                 
                 sout=systime()
                 sout=[sout,' --- Forward calculation ---']
                 sout=[sout,' Nsurf = '+strtrim(string(star.ntot,form='(I5)'),2)]
                 sout=[sout,' Incl  = '+strtrim(string(star.incl,form='(I3," degrees")'),2)]
                 sout=[sout,' Vsini = '+strtrim(string(star.vsini,form='(F5.1," km/s")'),2)]
                 sout=[sout,' FWHM  = '+strtrim(string(star.fwhm,form='(F5.1," km/s")'),2)]
                 if star.snr gt 0 then sout=[sout,' S/N   = '+strtrim(string(star.snr,form='(I4)'),2)]
                 if spots.n gt 0 then begin
                   sout=[sout,' Spot type: '+(['continuum brightness','line strength'])[star.type]]
                   sout=[sout,' Spot parameters:']
                 endif
                 for k=0,spots.n-1 do sout=[sout,string(spots.tbl[*,k],form='(4F7.1)')]
                 sout=[sout,'']
                 openw,un,defaults.logfile,/get_lun,/append
                 for k=0,n_elements(sout)-1 do begin
                   printf,un,sout[k]
                   print,sout[k]
                 endfor
                 free_lun,un
                 
                 Widget_Control, Widget_Info(event.top,find_by_uname='PrfInv'), $
                   sensitive=max(strpos(tag_names(syn_input),'OBS')) ne -1
                 Widget_Control, Widget_Info(event.top,find_by_uname='PrfSave'), $
                   sensitive=1
               endcase
  'PrfInv'   : begin
                 Widget_Control, /Hourglass

                 star_inv={ntot:invp.ntot,type:star.type,incl:invp.incl, $
                           vsini:invp.vsini,fwhm:star.fwhm,d:star.d,limbd:star.limbd, $
                           nphases:star.nphases,vrange:star.vrange,vstep:star.vstep,snr:star.snr}
                 DI_GridInit,star_inv.ntot,grid_inv
                 map_inv=replicate(1d0,star_inv.ntot)

                 sout=systime()
                 sout=[sout,' --- Inversion ---']
                 sout=[sout,' Nsurf  = '+strtrim(string(star_inv.ntot,form='(I5)'),2)]
                 sout=[sout,' Incl   = '+strtrim(string(star_inv.incl,form='(I3," degrees")'),2)]
                 sout=[sout,' Vsini  = '+strtrim(string(star_inv.vsini,form='(F5.1," km/s")'),2)]
                 sout=[sout,' Lambda = '+strtrim(string(invp.lambda,form='(E7.1)'),2)]
                 sout=[sout,' Regularization type: '+(['Tikhonov','ME'])[invp.regtype]]
                 openw,un,defaults.logfile,/get_lun,/append
                 for k=0,n_elements(sout)-1 do begin
                   printf,un,sout[k]
                   print,sout[k]
                 endfor
                 free_lun,un
  
                 parinfo=replicate({value:0d0,fixed:0,tnmaxstep:0d0},star_inv.ntot)
                 parinfo.value=map_inv
                 parinfo[*].tnmaxstep=0.1d0
    
                 functargs={star:star_inv,grid:grid_inv,obs:syn_input,invp:invp}    
                 iterargs={star:star_inv,grid:grid_inv,defaults:defaults}  
                 map_inv=tnmin('DI_func',niter=niter,functargs=functargs,parinfo=parinfo,$
                         quiet=0,nocatch=0,errmsg=errmsg,autoderivative=0,bestmin=bestmin,$
                         nprint=1,iterproc='DI_iter',iterargs=iterargs,maxiter=invp.maxiter,$
                         maximize=invp.regtype)
               endcase              
  'PrfSave'  : begin
                 outfile=dialog_pickfile(title='Name save output file',filter='*sav',file='didemo_test1.sav')
                 if file_test(outfile,/directory) then begin
                   print,'No proper output file name selected. Nothing is saved'
                 endif else begin
                   save,file=outfile,star,spots,invp,grid_input,map_input,syn_input,defaults
                   print,'Created save file in '+outfile
                 endelse
               endcase
  'PrfRest'  : begin
                 inpfile=dialog_pickfile(title='Select input save file',filter='*sav')
                 if not file_test(inpfile,/read) or file_test(inpfile,/directory) then begin
                   print,'No proper input file selected'
                 endif else begin
                   restore,inpfile
                   print,'Reading data from '+inpfile
                   print,'Relaunching GUI'                   
                   device,window_state=wn
                   ii=where(wn eq 1,ni)
                   for i=0,ni-1 do wdelete,ii[i]
                   Widget_Control, event.top, /destroy
                   DI_Gui, /show
                 endelse
               endcase               
  'GuiQuit'  : begin
                 device,window_state=wn
                 ii=where(wn eq 1,ni)
                 for i=0,ni-1 do wdelete,ii[i]
                 Widget_Control, event.top, /destroy
               endcase
  else       : begin
                 print,'Error in event handling'
                 stop
               endcase
  endcase

end

;===========================================================================
Pro DI_Gui, show=show

common geninfo,star,spots,invp,grid_input,map_input,syn_input,defaults

  tlb = Widget_Base(title='DI Demo  Oleg Kochukhov', /Column, /Base_Align_Left)
  lfont = defaults.lfont

  ba = Widget_Base(tlb, /Column, /Base_Align_Center, frame=1)
  bx = Widget_Label(ba, value='- Stellar parameters -', /Align_center, font=lfont)
  b1 = Widget_Base(ba, /Row, /Align_Left)
  bx = Widget_Label(b1, value=' Ntot')
  bx = Widget_DropList(b1, value=strtrim(defaults.ntot,2), uvalue='Ntot')
  Widget_Control, bx, set_droplist_select=(where(defaults.ntot eq star.ntot))[0]
  bn = Widget_Base(b1, /Row, /Align_Left)
  bx = Widget_Label(bn, value=' Incl')
  bx = Widget_Text(bn, value=string(star.incl,form='(I4)'), uvalue='Incl', /editable, xsize=5)
  bx = Widget_Label(bn, value=' Vsini')
  bx = Widget_Text(bn, value=string(star.vsini,form='(F5.1)'), uvalue='Vsini', /editable, xsize=5)
    
  bb = Widget_Base(tlb, /Column, /Base_Align_Center, frame=1)
  bx = Widget_Label(bb, value='- Line parameters -', /Align_center, font=lfont)
  b2 = Widget_Base(bb, /Row, /Align_Left)
  bx = Widget_Label(b2, value=' Depth')
  bx = Widget_Text(b2, value=string(star.d,form='(F5.2)'), uvalue='Depth', /editable, xsize=5)
  bx = Widget_Label(b2, value=' FWHM')
  bx = Widget_Text(b2, value=string(star.fwhm,form='(F5.1)'), uvalue='Fwhm', /editable, xsize=5)
  bx = Widget_Label(b2, value=' Limbd')
  bx = Widget_Text(b2, value=string(star.limbd,form='(F5.2)'), uvalue='Limbd', /editable, xsize=5)
  bx = Widget_Label(b2, value=' Vstep')
  bx = Widget_Text(b2, value=string(star.vstep,form='(F5.1)'), uvalue='Vstep', /editable, xsize=5)

  bc = Widget_Base(tlb, /Column, /Base_Align_Center, frame=1)
  bx = Widget_Label(bc, value='- Spot parameters -', /Align_center, font=lfont)
  b3 = Widget_Base(bc, /Row, /Align_Left)
  bn = Widget_Base(b3, /Row, /Align_Left)
  bx = Widget_Label(bn, value=' Nspot')
  bx = Widget_Text(bn, value=string(spots.n,form='(I4)'), uvalue='Nspot', /editable, xsize=4)
  bx = Widget_Label(b3, value=' Type')
  bx = Widget_DropList(b3, value=['Continuum brightness','Line strength'], uvalue='SpotType')
  Widget_Control, bx, set_droplist_select=spots.type
  bx = Widget_Table(bc, value=spots.tbl, column_labels=['Lon','Lat','Radius','Contrast'], $
  row_labels='Spot '+strtrim(indgen(spots.n)+1,2), /editable, form='(F5.1)', y_scroll_size=4, $
  alignment=2, uvalue='SpotTbl', uname='SpotTbl')

  bd = Widget_Base(tlb, /Column, /Base_Align_Center, frame=1)
  bx = Widget_Label(bd, value='- Forward calculation parameters -', /Align_center, font=lfont)
  b4 = Widget_Base(bd, /Row, /Align_Left)
  bx = Widget_Label(b4, value=' Nphase')
  bx = Widget_Text(b4, value=string(star.nphases,form='(I4)'), uvalue='Nphase', /editable, xsize=4)
  bx = Widget_Label(b4, value='   ')
  bn = Widget_Base(b4, /Row, /Nonexclusive)
  bx = Widget_Button(bn, value=' Add noise', uvalue='Noise')  
  Widget_Control, bx, set_button=star.snr gt 0  
  bx = Widget_Label(b4, value='S/N', uvalue='SNRlbl', uname='SNRlbl')
  Widget_Control, bx, sensitive=star.snr gt 0
  bx = Widget_Text(b4, value=string(abs(star.snr),form='(I5)'), uvalue='SNRval', uname='SNRval', /editable, xsize=5)
  Widget_Control, bx, sensitive=star.snr gt 0

  be = Widget_Base(tlb, /Column, /Base_Align_Center, frame=1)
  bx = Widget_Label(be, value='- Inversion parameters -', /Align_center, font=lfont)
  b5 = Widget_Base(be, /Row, /Align_Left)
  bx = Widget_Label(b5, value=' Ntot')
  bx = Widget_DropList(b5, value=strtrim(defaults.ntot,2), uvalue='NtotInv')
  Widget_Control, bx, set_droplist_select=(where(defaults.ntot eq invp.ntot))[0]
  bn = Widget_Base(b5, /Row, /Align_Left)
  bx = Widget_Label(bn, value=' Incl')
  bx = Widget_Text(bn, value=string(invp.incl,form='(I4)'), uvalue='InclInv', uname='InclInv', /editable, xsize=5)
  bx = Widget_Label(bn, value=' Vsini')
  bx = Widget_Text(bn, value=string(invp.vsini,form='(F5.1)'), uvalue='VsiniInv', uname='VsiniInv', /editable, xsize=5)  
  bn = Widget_Base(be, /Row, /Align_Left)
  bx = Widget_Label(bn, value=' Regul. type')
  bx = Widget_DropList(bn, value=['Tikhonov','Max entropy'], uvalue='RegType')
  Widget_Control, bx, set_droplist_select=invp.regtype
  bx = Widget_Label(bn, value=' Regul. value')
  bx = Widget_Text(bn, value=string(invp.lambda,form='(e7.1)'), uvalue='RegVal', uname='RegVal', /editable, xsize=7)

  bf = Widget_Base(tlb, /Column, /Base_Align_Center, /Align_Center, frame=1, xpad=1, ypad=1)
  b6 = Widget_Base(bf, /Row, /Align_Center, xpad=1, ypad=1)
  bt0 = Widget_Button(b6, value='CALCULATE', uvalue='PrfCalc', font=lfont)
  bt1 = Widget_Button(b6, value='INVERT', uvalue='PrfInv', uname='PrfInv', font=lfont)
  Widget_Control, bt1, sensitive=0
  b7 = Widget_Base(bf, /Row, /Align_Center, xpad=0, ypad=0)
  bt2 = Widget_Button(b7, value='RESTORE', uvalue='PrfRest', font=lfont)
  bt3 = Widget_Button(b7, value='SAVE', uvalue='PrfSave', uname='PrfSave', font=lfont)
  Widget_Control, bt3, sensitive=0
  b8 = Widget_Base(bf, /Row, /Align_Center, xpad=0, ypad=0)
  bt4 = Widget_Button(b8, value='QUIT', uvalue='GuiQuit', font=lfont)

  Widget_Control, tlb, /Realize

  g=Widget_Info(bb, /geometry) 
  Widget_Control, ba, xsize=g.scr_xsize
  Widget_Control, bc, xsize=g.scr_xsize
  Widget_Control, bd, xsize=g.scr_xsize
  Widget_Control, be, xsize=g.scr_xsize
  Widget_Control, bf, xsize=g.scr_xsize

  g1=Widget_Info(bt0, /geometry) 
  bsize=g1.scr_xsize>(g.scr_xsize*0.47)
  Widget_Control, bt0, xsize=bsize
  Widget_Control, bt1, xsize=bsize
  Widget_Control, bt2, xsize=bsize
  Widget_Control, bt3, xsize=bsize
  Widget_Control, bt4, xsize=bsize*2

  if keyword_set(show) then begin
    g=Widget_Info(tlb, /geometry) 
    xpos=g.xsize+g.xoffset+1                 
    DI_Plot,map_input,syn_input,grid_input,star.incl, $  
      title='Forward calculation',type=star.type,     $
      rout=mr,di=defaults.di,xpos=xpos,xref=xref
    if max(strpos(tag_names(defaults),'MRANGE')) ne -1 then defaults.mrange=mr $
    else defaults=create_struct(defaults,'mrange',mr)
    if max(strpos(tag_names(defaults),'XREF')) ne -1 then defaults.xref=xref $
    else defaults=create_struct(defaults,'xref',xref)
  endif

  Xmanager, 'DI_Gui', tlb, event_handler = 'DI_event'

end

;===========================================================================
Pro didemo_gui

common geninfo,star,spots,invp,grid_input,map_input,syn_input,defaults

;  =========================================================================
;  ====  INPUT PARAMETERS FOR DI_DEMO PROGRAM
;  =========================================================================
;
;  ====  stellar parameters
;
def_ntot=[1176,1876,3909,10173]     ; default total number of surface elements to choose from
ntot=3909                           ; total number of surface elements
incl=50d0                           ; inclination angle
vsini=50d0                          ; projected rotational velocity in km/s
limbd=0.5d0                         ; linear limb darkening coefficient
fwhm=7d0                            ; FWHM of Gaussian profile in km/s
depth=0.6d0                         ; depth of local profile
;
;  ====  spectrum parameters
;
vrange=sqrt(vsini^2+fwhm^2)         ; range of velocities
vstep=1.0d0                         ; step of velocity grid in km/s
nphases=20                          ; number of equidistant rotation phases
;
;  ====  spot parameters
;
lon_spot=[40.,130.,220.,310.]       ; spot longitudes (degrees)
lat_spot=[-30.,0.,60.,30.]          ; spot latitudes (degrees)
c_spot=[0.2,3.0]                    ; spot contrast (between 0 and 1 for continuum brightness, >1 for line strength)
r_spot=20.                          ; spot radius (degrees)
type_spot=1                         ; spot type: 0=continuum brightness, 1=line strength
;
;  ====  simulation of observations and inversion
;
snr=[500.,300.]                     ; S/N ratio; observations are simulated if snr is non-zero 
ntot_inv=1876                       ; total number of surface elements for inversion
vsini_inv=vsini                     ; projected rotational velocity for inversion
incl_inv=incl                       ; inclination angle for inversion
lambda_tik=[1d2,2d1]                ; Tikhonov regularisation parameter, default values for type=0 and type=1 problems
lambda_mem=[1d2,1d2]               ; MEM regularisation parameter
regtype=0                           ; regularization type: 0=Tikhonov, 1=MEM
maxiter=30                          ; Maximum number of iterations
;
;  =========================================================================
; Don't report underflows from Gaussian profile computations
!except=0

; Same setting as in startup file which is not read in vm mode
device,true_color=24,decomposed=0

; Structure containting other default parameters
defaults={ntot:def_ntot,lambda_tik:lambda_tik,lambda_mem:lambda_mem, $
          snr:snr,c_spot:c_spot,di:0.6d0,rscale:1.4,logfile:'didemo.log', $
          lfont:'*helvetica-medium-r-*-140-*'}

; Structure containing stellar parameters
star={ntot:ntot,type:type_spot,incl:incl,vsini:vsini,fwhm:fwhm,d:depth, $
      limbd:limbd,nphases:nphases,vrange:vrange*defaults.rscale, $
      vstep:vstep,snr:snr[type_spot]}

; Check sanity of initial spot parameters 
nspot=n_elements(lon_spot)
if n_elements(lat_spot) ne nspot or $
  (n_elements(r_spot) ne 1 and n_elements(r_spot) ne nspot) then begin
  print,'Input spot parameters error. Aborting.'
  stop
endif
if n_elements(r_spot) eq 1 then r_spot=replicate(r_spot,nspot)
c_spot=replicate(c_spot[star.type],nspot)
tbl=transpose([[lon_spot],[lat_spot],[r_spot],[c_spot]])
spots={n:nspot,type:type_spot,tbl:tbl}

; Structure containing inversion parameters
lambda=regtype eq 0 ? lambda_tik[type_spot] : lambda_mem[type_spot]
invp={ntot:ntot_inv,vsini:vsini_inv,incl:incl_inv,lambda:lambda,regtype:regtype,maxiter:maxiter}

; Launch GUI interface handling over control to DI_event
DI_Gui

end

